<script setup lang="ts">
import { usePromotionStore } from '@/stores/promotion'
import { useReceiptStore } from '@/stores/receipt'
import { useMemberStore } from '@/stores/member'
import { type Promotion } from '@/types/Promotion'
import { onMounted, ref, watch, computed } from 'vue'
import MemberCard from '@/views/POS/MemberCard.vue'
import ReceiptDialog from '@/views/POS/ReceiptDialog.vue'
import PaymentType from '@/views/POS/PaymentType.vue'
import QRpayment from '@/views/POS/QRpayment.vue'
import { useRouter } from 'vue-router'

const PromotionStore = usePromotionStore()
const receiptStore = useReceiptStore()
const memberStore = useMemberStore()
const router = useRouter()

onMounted(() => {
  PromotionStore.getPromotions()
})

const totalToPay = computed(() => {
  const totalPrice = receiptStore.receipt!.totalPrice;
  const promotionDiscount = receiptStore.receipt!.promotionDiscount;
  return Math.max(0, totalPrice - promotionDiscount);
});

const memberPoint = computed(() => {
  const currentMember = memberStore.getCurrentMember()
  return currentMember ? currentMember.point : 0
})

const selectedPromotions = ref<string[]>([])
const productName = ref<String[]>([])
const dialogReceipt = ref(false)

function clear() {
  selectedPromotions.value = []
}

//when click and check member
const handleSelectClick = () => {
  const activePromotions = computed(() =>
    PromotionStore.promotions.value.filter((promotion: Promotion) => promotion.status === 'Active')
  )
  const currentMember = memberStore.getCurrentMember()
  if (currentMember) {
    productName.value = activePromotions.value.map((promotion: Promotion) => promotion.name)
  } else {
    const memberPromotions = computed(() =>
      activePromotions.value.filter((promotion: Promotion) => promotion.details === 'Guest')
    )
    productName.value = memberPromotions.value.map((promotion: Promotion) => promotion.name)
  }
}

function getProdiscount(selectedPromotions: string[]): number {
  let discountAmount = 0
  for (const promotionName of selectedPromotions) {
    const promotion = PromotionStore.promotions.value.find((promotion: Promotion) => promotion.name === promotionName)
    if (promotion) {
      discountAmount += promotion.discount
      console.log("แต้ม", discountAmount)
    }
  }
  return discountAmount
}

function getPointsUsed(selectedPromotions: any) {
  let pointUse = 0;
  for (const promotionName of selectedPromotions) {
    const promotion = PromotionStore.promotions.value.find((promotion: Promotion) => promotion.name === promotionName);
    if (promotion) {
      pointUse += promotion.pointUse;
    }
  }
  return pointUse;
}

watch(selectedPromotions, (newSelectedPromotions) => {
  const discountValue = getProdiscount(newSelectedPromotions)
  receiptStore.updateDiscount(discountValue)
  const pointUse = getPointsUsed(newSelectedPromotions)
  const totalPoint = (memberPoint.value !== undefined ? memberPoint.value : 0) - pointUse
  console.log(totalPoint)
  receiptStore.getPoint(totalPoint)
})

function navigateToPOSView() {
  selectedPromotions.value = []
  router.push('/pos')
}

function backPromotions() {
  selectedPromotions.value = []
}

function resetPromotions() {
  selectedPromotions.value = []
  receiptStore.clear()
  memberStore.clearFrom()
}
</script>

<template>
  <v-container>
    <!-- Member section -->
    <v-row justify="center">
      <v-col cols="12">
        <h3 class="title">สมาชิก</h3>
      </v-col>
      <v-col cols="12" sm="12" md="12">
        <MemberCard></MemberCard>
      </v-col>
    </v-row>
    <v-divider></v-divider>

    <!-- Promotion section -->
    <v-row justify="center" class="mt-2">
      <v-col cols="12">
        <h3 class="title">โปรโมชั่น</h3>
      </v-col>
      <v-col cols="12" sm="12" md="12" class="mt-1">
        <v-select chips multiple label="Select promotion" v-model="selectedPromotions" :items="productName"
          variant="outlined" @click="handleSelectClick" bg-color="white" rounded density="compact"></v-select>
      </v-col>
    </v-row>
    <v-divider></v-divider>

    <!-- Details section -->
    <v-row justify="center" class="mb-2 mt-1">
      <v-col cols="12">
        <h3 class="title">รายละเอียดการชำระเงิน</h3>
      </v-col>
      <!-- <v-col cols="12" sm="10" md="8"> -->
      <v-col cols="12" md="6" sm="6">
        <v-card elevation="1">
          <v-list-item prepend-icon="mdi-ticket-account">
            <v-list-item-content>
              <v-list-item-title>ส่วนลดสมาชิก : {{ receiptStore.receipt?.discount }}</v-list-item-title>
            </v-list-item-content>
          </v-list-item>
        </v-card>
      </v-col>

      <v-col cols="12" md="6" sm="6">
        <v-card elevation="1">
          <v-list-item prepend-icon="mdi-brightness-percent">
            <v-list-item-content>
              <v-list-item-title>ส่วนลดโปรโมชั่น : {{ getProdiscount(selectedPromotions) }}</v-list-item-title>
            </v-list-item-content>
          </v-list-item>
        </v-card>
      </v-col>

      <v-col cols="12" md="6" sm="6">
        <v-card elevation="1">
          <v-list-item prepend-icon="mdi-ticket-percent">
            <v-list-item-content>
              <v-list-item-title>แต้มที่ใช้ : {{ getPointsUsed(selectedPromotions) }}</v-list-item-title>
            </v-list-item-content>
          </v-list-item>
        </v-card>
      </v-col>

      <v-col cols="12" md="6" sm="6">
        <v-card elevation="1">
          <v-list-item prepend-icon="mdi-wallet-outline">
            <v-list-item-content>
              <v-list-item-title>แต้มคงเหลือ : {{ (memberPoint !== undefined ? memberPoint : 0) -
                getPointsUsed(selectedPromotions) }}</v-list-item-title>
            </v-list-item-content>
          </v-list-item>
        </v-card>
      </v-col>


      <v-col cols="12" md="12" sm="12">
        <v-card elevation="1">
          <v-list-item prepend-icon="mdi-account-cash">
            <v-list-item-content>
              <v-list-item-title>ยอดรวม : {{ totalToPay }}</v-list-item-title>
            </v-list-item-content>
          </v-list-item>
        </v-card>
      </v-col>
    </v-row>
    <!-- </v-col> -->
    <v-divider></v-divider>

    <!-- Payment section -->
    <v-row justify="center" class="mb-2 mt-1">
      <v-col cols="12">
        <h3 class="title">วิธีการชำระเงิน</h3>
      </v-col>
      <v-col cols="12" sm="10" md="8">
        <v-row>
          <v-col cols="12" md="6">
            <PaymentType></PaymentType>
          </v-col>
          <v-col cols="12" md="6">
            <QRpayment></QRpayment>
          </v-col>
        </v-row>
      </v-col>
    </v-row>
    <v-divider></v-divider>

    <!-- Navigation section -->
    <v-row justify="center" class="mt-2">
      <v-col cols="12" sm="12" md="12">
        <v-row>
          <v-col cols="6">
            <v-btn class="align-right" variant="plain" elevation="4" size="large" prepend-icon="mdi-arrow-left" block
              rounded="xl" @click="navigateToPOSView">
              กลับ
            </v-btn>
          </v-col>
          <v-col cols="6">
            <v-btn class="align-right" variant="plain" elevation="4" size="large" prepend-icon="mdi-close-thick" block
              rounded="xl" @click="resetPromotions()">ยกเลิก</v-btn>
          </v-col>
        </v-row>
      </v-col>
    </v-row>

  </v-container>
</template>

<style scoped>
.title {
  text-align: center;
  margin-bottom: 10px;
  /* ปรับระยะห่างด้านล่าง */
}

.v-card {
  /* text-align: center;
  border: 2px solid; */
  font-family: 'Franklin Gothic Medium', 'Arial Narrow', Arial, sans-serif;
  /* font-size: 70px;
  color: #412f26; */
} 

.v-sheet,
.v-card {
  border-radius: 100px;
  text-decoration: none;
}

.v-btn {
  background-color: #ffcb5e;
  border-radius: 80px;
  display: flex;
  justify-content: center;
  align-items: center;
  color: black;
}
</style>
